 
{
     This program moves 5 axis in smooth liner interpolative motion from a current position
     to the next position called.

     The essence of liner interpolative multi-axis stepper motion control is to

     1.  figure out how many steps away from the desired position each axis is.
     2.  the largest movement ( step count ) becomes your base step count.
     3.  divide every other axis step count by the base step count.  These values are the relative step size.
     4.  Set the direction bit for each axis.
     5.  Begin stepping the base step count number of steps.
     6.  Add the relative step size to a hold value for each axis. If this new value is greater or equal
        to 1, then this axis will take a step this time as well.  Set it to step and subtract 1 from that
        axis hold value. 
     7. as each axis takes a step, incriment or decriment the position according to the direction flag.

        
    the xyz axis on the machine this code was written for are linear while the w&r axis are rotary, but it
    shouldn't be an issue to switch any or all axis to polar or cartesian as needed.     


    This code is for step and dirction outputs, however, the "take1step" function can easily be modified to
    sequence transistors using a lookup/lookdown phase table.   The table can be populated for full or half
    steps as desired.
    
    I stuffed 4 axes into an SX-52 in assembly, so if someone wants to take the ball and run with it,
    the Propeller should give really nice speed for eight or nine axis if someone wanted to recode it in
    pasm.  
     

    I wanted the basic code to be as small as possible so I left some helpful stuff commented out at the
    end.  ( test moves and such ) 

    This code is pruned from a working program.   I just pulled out all the unnecessary stuff and am going
    to post it without testing.  If something doesn't work, let me know I'll make it work. 

    
    Ken Bash      
           
 }

obj
 ' text    : "vga_text_PY"

 
       f    : "float32"
       
      fp    : "FloatString" 

  '  text    : "tv_wtext"
          
  '    ser    : "FullDuplexSerial"   

  '   pk    : "packetcom"
     
  '     servo : "servo4"
          
con

   _clkmode = xtal1 + pll16x
   _xinfreq = 5_000_000
  
dlatime = 1000

                     ' direction flags
xout = 1
xin  = !xout 

yout = 0
yin = !yout

zout = 0
zin = !zout


 'motor step and direction pins:

stpw = 10  
dirw = 11   

  
stpx = 0
dirx = 1

stpy = 2
diry = 3

stpz = 4
dirz = 5

 

 STPr = 7 
 DIRr = 8
       
  
              '  input limit pins
rotlim          = 24
wlim            = 26
xlim            = 29               
ylim            = 22
zlim            = 23
 
                      

maxspeed = 5 
 
    
  
var                                   
                   ' note ** speed ramping is not implimented in this version.
                   
 long startspeed
 
 long movespeed

 long thispeed        
 
 long steps2go            ' total number of steps for this movement
 
 long rampsteps           ' total number of steps to move while ramping speed up and down     
 long upsteps             ' number of steps increasing speed  
 long dnsteps             ' number of steps decreasing speed
 long consteps            ' steps to move at a constant speed
 long ramprate            ' rate to ramp up and down speeds
  
 long radd
 long xadd        
 long yadd             
 long zadd            
 long wadd                ' cumulative steps for all axis durring a move                                        

 long rat
 long xat                 
 long yat            
 long zat             
 long wat                 ' current position of all axis

 long rto
 long xto             
 long yto             
 long zto             
 long wto                 ' position you are moving each axis to   
 
 long rsteps              
 long xsteps          
 long ysteps           
 long zsteps            
 long wsteps              ' number of steps each axis will move 
  
 long rstepsz
 long xstepsz           
 long ystepsz           
 long zstepsz           
 long wstepsz             ' relative size of each axis movement  

long rdir                ' direction flags for each axis
long xdir            
long ydir           
long zdir             
long wdir             ' change these to bits later

long stepsize           

 
long atx          ' to5 positions
long aty
long atz
long atw
long atr

long xsm
long ysm
long zsm
  
          
PUB Main         


   ' initialize the outputs
   
     dira[stpx] := 1
     dira[dirx] := 1
     dira[stpy] := 1
     dira[diry] := 1
     dira[stpz] := 1
     dira[dirz] := 1
     dira[stpw] := 1
     dira[dirw] := 1
     dira[stpr] := 1
     dira[dirr] := 1
     
   
    movespeed := 20




         ' a machine is often stopped in a position that if you do a multi-axis home immediately,
         ' you will damage something.   ( for instance a cutter is in the bottom of a hole )
         ' so these homing functions always home the Z axis first to clear any tooling or work,
         ' then home the other axis once you are clear.  My work often involves tooling that
         ' will hit things if you home the rotating axis(s) when the machine is in the XY home position
         ' so I sometimes put a xy go inbetween the xyz and the rotation home functions.
    
    
                 
              homeit   ' home the z axis first, then the x&y axis              
              homer   ' home the rotation axis
              HOMEW   ' home the w axis

              
  
            ' this is just a few test movements ( X, Y, Z, W, R, Speed )  
       
       
             go5(2000, 3000, 1000,1000, 2000, movespeed )
             go5(1000, 1000, 100,100,  20 , movespeed )
             go5(0, 0, 0,0,  0 , movespeed )

 
         '    put your movement stuff here.



              
      
                 
    repeat       ' NOW STOP HERE




 
   

  
PUB HOMER  | Rspeed , debounce           ' home the rotary axis


 Rspeed := 50000

 debounce := 0 

   DIRA[dirr] := 1
   DIRA[stpr] := 1
   

    
        OUTA[DIRr] := 0

  debounce := rotck 
   
       

       REPEAT while  debounce > 5  ' drive out of the home limit  

          OUTA[STPR] := 1

          WAITCNT (CNT + Rspeed)
          
           OUTA[STPR] := 0
  
          WAITCNT (CNT + Rspeed)
          
          debounce := rotck
          
          
  
      OUTA[DIRr] := 1        

   
       REPEAT while  ina[rotlim] == 1  

          OUTA[STPR] := 1

          WAITCNT (CNT + Rspeed)
          
           OUTA[STPR] := 0
  
          WAITCNT (CNT + Rspeed)
          

  OUTA[DIRr] := 0
   
  
  debounce := rotck 
   
       

       REPEAT while  debounce > 5  ' drive out of the home limit  

          OUTA[STPR] := 1

          WAITCNT (CNT + Rspeed)
          
           OUTA[STPR] := 0
  
          WAITCNT (CNT + Rspeed)
          
          debounce := rotck
       



  
  
  rat := 0             ' set rotation axis position to zero
          
          

     
pri rotck       | count         ' this is to debounce a noisy limit signal

 count := 0
   repeat 8
    if  (ina[rotlim] == 0 )
     count ++
     waitcnt(cnt + 5000)

  '   count := 5
     
   return( count)
                                  
PUB HOMEW   | wspeed            ' home the W axis


 wspeed := 40000

   DIRA[dirw] := 1
   DIRA[stpw] := 1
   
   OUTA[DIRW] := 1
   
   REPEAT while  ina[wlim] == 1  
          OUTA[STPW] := 1

          WAITCNT (CNT + wspeed)
          
           OUTA[STPW] := 0

          WAITCNT (CNT + wspeed)

          
      ' now drive out of W home 

   outa[dirw]  := 0

          REPEAT while  ina[wlim] == 0  
       
            OUTA[STPW] := 1

             WAITCNT (CNT + wspeed)
          
           OUTA[STPW] := 0

            WAITCNT (CNT + wspeed)

 {        ' to position W axis a certian value off of the limit switch
    
          REPEAT whomeval 
       
            OUTA[STPW] := 1

             WAITCNT (CNT + wspeed)
          
           OUTA[STPW] := 0

            WAITCNT (CNT + wspeed)
  
  }          
      
 wat := 0           ' set w axis position to zero
 
                                                        

pub homeit      | xhome, yhome,zhome         ' home the XY and Z axis


xhome := yhome := zhome := 1

movespeed := 100


 Driveoutofhome             'if you're currently in a limit, drive out of it

 

outa[dirx] := xin           ' set the directions to move toward the home limits
outa[diry] := yin
outa[dirz] := zin
         
         ' home the  z axis first to clear obstackals
         
          repeat while( zhome ==1)
                            
             outa[stpz] := zhome    
              zhome := ina[zlim]        
              speedla
             outa[stpz] := 0        
               speedla
      

       
      repeat while( xhome == 1 or yhome == 1 )        
       
              outa[stpx] := xhome
              outa[stpy] := yhome
                  
                   xhome := ina[xlim]    
                   yhome := ina[ylim]                      
       
         speedla
         outa[stpx] :=  outa[stpy] := 0
        
         speedla
       
       
   driveoutofhome
   
     xat := yat := zat := 0
     
    
pri Driveoutofhome      | xhome, yhome,zhome     

' now drive out of the limits


  xhome := yhome := zhome := 1

outa[dirx] := xout
outa[diry] := yout
outa[dirz] := zout

repeat while(xhome == 1 or yhome == 1 or zhome == 1)

  xhome := yhome := zhome := 0
  
       if ina[xlim] == 0
          xhome := 1
        
       if ina[ylim] == 0
          yhome := 1
          
       if ina[zlim] == 0
          zhome := 1

      outa[stpx] := xhome
      outa[stpy] := yhome
      outa[stpz] := zhome
        
   speedla
   outa[stpx] :=  outa[stpy] := outa[stpz] := 0
   speedla
            
 
 
             
pub go5(xpos, ypos, zpos, wpos , rpos, speed )
        
        
            movespeed :=  speed          ' set the speed for this pulse group   
 
      
            xto := xpos          ' set the x goto position 
      
            yto := ypos          ' set the y goto position 
        
            zto := zpos          ' set the z goto position 
       
            wto := wpos          ' set the w goto position
            
            rto := rpos           ' r pos.
    
            set2go                 ' set all the movement stuff
            
            takesteps              ' now move all 5 axis where they need to go.

 
            
pub set2go     | steps 

                         ' first figure out which direction each axis must move
                         ' setting a direction to 1 or -1 lets the direction always be added to the
                         ' current position for each step

                         
      if xat < xto        '( direction is positive ) 
          xdir :=  1
          outa[dirx] := 1
          
         xsteps :=     xto - xat 
      else
          xdir := -1
          outa[dirx] := 0        
          xsteps := xat - xto

      if yat < yto        '( direction is positive ) 
          ydir :=  1
         outa[diry] := 0         
         ysteps :=     yto - yat 
      else
          ydir := -1
          ysteps := yat - yto
          outa[diry] := 1       

      if zat < zto        '( direction is positive ) 
          zdir :=  1
         zsteps :=     zto - zat
           outa[dirz] := 0     
         
      else
          zdir := -1
          zsteps := zat - zto
             outa[dirz] := 1      

      if wat < wto        '( direction is positive ) 
          wdir :=  1
         wsteps :=     wto - wat
         outa[dirw] := 0
      else
          wdir := -1
          wsteps := wat - wto
          outa[dirw] := 1


      if rat < rto        '( direction is positive ) 
          rdir :=  1
         rsteps :=     rto - rat
         outa[dirr] := 0
      else
          rdir := -1
          rsteps := rat - rto                                                                      
          outa[dirr] := 1

          
          

                                ' keep mpoving the largest step into steps2go to get the basecount of steps
     steps2go := xsteps
     
     if steps2go < ysteps
        steps2go := ysteps
        
     if steps2go < zsteps
        steps2go := zsteps
 
     if steps2go < wsteps
        steps2go := wsteps    

     if steps2go < rsteps
        steps2go := rsteps    
                               
   
     steps := steps2go
     

   {           ramping function not implimented
      

     if steps >  rampsteps * 2                  ' then it's a 3 piece move
              upsteps := rampsteps / 2          ' set the up and down steps
              dnsteps := rampsteps / 2          ' set the up and down steps

           
          consteps := steps - rampsteps                  ' set the constant steps 
         
     else
      if steps >  1
         upsteps  := steps / 2
         dnsteps  := steps - upsteps
         consteps := 0
      
       }   
     
                                           ' set the relative size of each step 
        
 
     xstepsz := f.fdiv(xsteps, steps)   
           
     ystepsz := f.fdiv(ysteps, steps )
            
     zstepsz := f.fdiv(zsteps, steps )
                
     wstepsz := f.fdiv(wsteps, steps ) 
                                 
     rstepsz := f.fdiv(rsteps, steps )


 
pub takesteps 
    
 
 repeat steps2go
   take1step

   

pub take1step       | xad, yad, zad, wad, rad, xcnt, ycnt, zcnt, wcnt,rcnt


  xcnt := xstepsz 
  ycnt := ystepsz
  zcnt := zstepsz  
  wcnt := wstepsz
  rcnt := rstepsz
  

    
   xad := f.fadd( xad, xstepsz)    
   
   if xad > 1                  ' time to take a step
     xad :=  f.fsub(xad, 1.0 )
          
      if xdir==1         
        xat++

        outa[stpx] := 1      
      else 
      
        xat--
        outa[stpx] := 1      
        
  yad := f.fadd( yad , ystepsz)
  
   if yad > 1
                 ' time to take a step
     yad   := f.fsub(yad, 1.0) 
       
      if ydir==1   
        yat++  
        outa[stpy] := 1           ' set the port bit high
      else 
         outa[stpy] := 1
        yat--
     
  zad := f.fadd( zad , zstepsz)
  
   if zad > 1                  ' time to take a step
   
     zad := f.fsub(zad, 1.0)
           
      if zdir==1  
        zat++
        outa[stpz] := 1
        
      else  
        zat--
         outa[stpz] := 1   

   wcnt := wstepsz      
  wad := f.fadd( wad , wstepsz) 
   if wad > 1                  ' time to take a step
     wad := f.fsub(wad, 1.0)
         
      if wdir==1  
        wat++
         outa[stpw] := 1         
      else 
        wat--   
         outa[stpw] := 1

  rcnt := rstepsz      
  rad := f.fadd( rad , rstepsz) 
   if rad > 1                  ' time to take a step
     rad := f.fsub(rad, 1.0)
         
      if rdir==1  
        rat++
         outa[stpr] := 1         
      else 
        rat--   
         outa[stpr] := 1          
 
   speedla     ' wait betweeen each step
 
      outa[stpx] := 0
      outa[stpy] := 0
      outa[stpz] := 0
      outa[stpw] := 0
      outa[stpr] := 0
                            

Pub speedla
 

  waitcnt ( cnt + movespeed * 220 + 800)


{

   ' The following could be useful

   
                                                                
pub takesteps2ax  | xad, yad, zad, wad, xcnt, ycnt, zcnt, wcnt
    
' this is just a bit faster than moving all 5 axis at the same time.    

  xcnt := xstepsz 
  ycnt := ystepsz    

 
 repeat steps2go           
       
   xad := f.fadd( xad, xstepsz)  
   
   if xad > 1                  ' time to take a step
     xad :=  f.fsub(xad, 1.0 )
          
      if xdir==1         
        xat++

        outa[stpx] := 1      
      else 
      
        xat--
        outa[stpx] := 1 


   
        
  yad := f.fadd( yad , ystepsz)
  
   if yad > 1
                 ' time to take a step
     yad   := f.fsub(yad, 1.0) 
       
      if ydir==1   
        yat++  
        outa[stpy] := 1           ' set the port bit high
      else 
         outa[stpy] := 1
        yat--
   
 
  speedla


 
      outa[stpx] := 0
      outa[stpy] := 0
    
        
 }


  

{            
pub go2(xpos, ypos )        ' 2 axis only      ( a bit faster than all 5 axis at once )
 
       
             xto := xpos          ' set the goto position 
   
             yto := ypos          ' set the goto position 
 
             set2go
           
            takesteps2ax

            
} 


   
{   
pub homeit3      | xhome, yhome,zhome      ' home 3 axis XYZ  at once 


xhome := yhome := zhome := 1

movespeed := 100


 Driveoutofhome

outa[dirx] := xin
outa[diry] := yin
outa[dirz] := zin
         
         ' home the  z axis first to clear obstackals
         
          repeat while( zhome ==1)
                            
             outa[stpz] := zhome    
              zhome := ina[zlim]        
              speedla
             outa[stpz] := 0        
               speedla
      

       
     repeat while( xhome == 1 or yhome == 1 ) ' or zhome ==1)
 
        
       
              outa[stpx] := xhome
              outa[stpy] := yhome
              outa[stpz] := zhome
        
        
                   xhome := ina[xlim]
    
                   yhome := ina[ylim]  

                    zhome := ina[zlim]
                   
       
         speedla
         outa[stpx] :=  outa[stpy] := 0
         outa[stpz] := 0
       
         speedla
       
       
   driveoutofhome
     xat := yat := zat :=  0

}        
 
      
{     
pub rtst             ' movement test function 
 repeat   2



   repeat  (3000)
       outa[dirr] := 1  
 
    outa[stpr] := 1
    waitcnt (cnt+ 8000)
    outa[stpr] :=0
    waitcnt (cnt+ 8000)

  repeat 500  
   outa[dirr] := 0
 
    outa[stpr] := 1
    waitcnt (cnt+ 8000)
    outa[stpr] :=0
    waitcnt (cnt+ 8000)
               
pub wtst
 repeat   5



   repeat 200
       outa[dirw] := 1  
 
    outa[stpw] := 1
    waitcnt (cnt+ 20000)
    outa[stpw] :=0
    waitcnt (cnt+ 20000)

  repeat 200  
   outa[dirw] := 0
 
    outa[stpw] := 1
    waitcnt (cnt+ 20000)
    outa[stpw] :=0
    waitcnt (cnt+ 20000)

   
pub xtst
 repeat



   repeat 2000
       outa[dirx] := 1  
 
    outa[stpx] := 1
    waitcnt (cnt+ 20000)
    outa[stpx] :=0
    waitcnt (cnt+ 20000)

  repeat 2000  
   outa[dirx] := 0
 
    outa[stpx] := 1
    waitcnt (cnt+ 20000)
    outa[stpx] :=0
    waitcnt (cnt+ 20000)

     
}    
    
   
 
{ 

pub to5(x,y,z,w,r, speed)     | wstps, rstps     ' 5 axis move to 10th inch positions and angular positions

    ' axis x,y,z in 1/10 inches from limit.

    ' axis w in + - degrees from zero  

    ' axis r in degrees from zero of home position

    ' these gearing factors will vary with your particular machine 

    atw := wstps := (( w *11111 ) / 1000)           ' 11.111steps per degree  
    atr := rstps := (( r * 11111 ) / 1000)          ' 11.111 steps per degree  
 
    atx := x*200             ' 200 steps = 1/10 inch movement
    aty := y*200
    atz := z*200   
    
{
    if (ckmove == 1 and speed > 999 )        ' ( used for point to point movement checks )
       speed := 1000 
    
 }
 
    go5(atx, aty, atz, wstps, rstps, speed )

        

}


{                          ' I don't think this ramping movement actually worked, but this is the basics of
                           ' how to do it. 
pub rampmove     | steps

 
  movespeed := thispeed :=  startspeed
  

'  ramprate := 10 
     

    if upsteps > 0                 ' ramp up to max speed
       repeat upsteps
         take1step

         
         thispeed := thispeed - ramprate
          if  thispeed > maxspeed
               movespeed := thispeed
          else
            movespeed := maxspeed     
         
    if consteps > 0                  ' move at a constant speed
       repeat consteps
         take1step

         
  thispeed := movespeed 

    if dnsteps > 0                    ' ramp down to slowest speed
       repeat dnsteps
         take1step 
         
         thispeed := thispeed + ramprate
         if thispeed < startspeed
            movespeed := thispeed
         else
            movespeed := startspeed
               
       
        

}
  